<?php
namespace Modules\Cotacao\Modules\ListaPreco\Controllers;

use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\Controller;
use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource;

class Sup05500DisponibilizacaoListaPreco extends \Teknisa\GER\Controllers\TeknisaCrud {

    protected $dataSourceName = "sup05500_disponibilizacao_lista_preco";
    protected $crudService;
    protected $parameterBagColumns = array("LISTACOMPR", "TLISTACOMPR", "DISPO", "NDISPO", "TLISTAPRECO", "LISTAPRECO", "CDFILIAL", "NRORG");
    
    public function __construct($crudService, ParameterBag $parameterBag, $environment, $connection) {
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->environment = $environment;
        $this->connection = $connection;
    }
    
    public function getCDFILCENTCMP() {
        $query = "SELECT NVL(CDFILCENTCMP, CDFILIAL) AS CDFILCENTCMP FROM FILIAL WHERE (CDFILIAL = :CDFILIAL)";
        $stmt = $this->connection->prepare($query);
        $stmt->execute(array(
            "CDFILIAL" => $this->environment->getCdFilial()
        ));
        return $stmt->fetchAll()[0]['CDFILCENTCMP'];
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $filterCriteria = $request->getFilterCriteria();
            $filterCriteria->setDataSourceName($this->dataSourceName);
            $filterCriteria = $this->crudService->getFilterCriteriaWithNrOrg($filterCriteria);
            $filterCriteria->addCondition("CDFILIAL", "=", $this->getCDFILCENTCMP());
            $newFilterCriteria = $this->crudService->getPopulatedFilterCriteria($filterCriteria, $this->parameterBagColumns);
            $this->crudService->find($response, $newFilterCriteria);
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
}